Help us understand the problem. What is going on with this article?

【メモ】ShellScriptでコマンドを実行したとき終了コードが0以外でも強制終了しないように終了コードを判定する

More than 3 years have passed since last update.

概要

test.sh
perl ExitCode1.pl
if [ 0 == $? ] ; then
    echo "error"
else
    echo "succeeded"
fi

実行結果

何も表示されない.

なんかperlを実行したとき終了コードが0以外だとshell scriptが即終了する

set -e つけてないのになぁ...
とはいえここは本記事の主題ではないのでどうでもいい。

終了しないように終了コードを判定する

test.sh
if ! perl ExitCode1.pl > /dev/null ; then
    echo "error"
else
    echo "succeeded"
fi

実行結果

error

追記

dev/nullへ飛ばすコードはいらないっぽい。

test.sh
if ! perl ExitCode1.pl ; then
    echo "error"
else
    echo "succeeded"
fi

追記の追記

set -e が入ってないと思ってたら入ってた。

Why do not you register as a user and use Qiita more conveniently?
  1. We will deliver articles that match you
    By following users and tags, you can catch up information on technical fields that you are interested in as a whole
  2. you can read useful information later efficiently
    By "stocking" the articles you like, you can search right away
Comments
Sign up for free and join this conversation.
If you already have a Qiita account
Why do not you register as a user and use Qiita more conveniently?
You need to log in to use this function. Qiita can be used more conveniently after logging in.
You seem to be reading articles frequently this month. Qiita can be used more conveniently after logging in.
  1. We will deliver articles that match you
    By following users and tags, you can catch up information on technical fields that you are interested in as a whole
  2. you can read useful information later efficiently
    By "stocking" the articles you like, you can search right away